# include	<stdio.h>
# include	<stdlib.h>
# include	<malloc.h>
# include	<string.h>
# include	<conio.h>

# include	"vcrplus.h"


long	debug = 0;

typedef struct fnc {
	long	newspaper;
	int	top5;
	int	bot3;
	int	channel;
	int	day;
	int	month;
	int	year;
	int	s4_out;
	int	s5_out;
	int	bump;
	int	start;
	int	duration;
	struct fnc	*next;
} fnc;

void		readin( long channel, long month_today, long year_today );
static void	printout( void );


int
main( int argc, char *argv[] )
{
	char	buffer[50];
	long	day_today = 1, month_today = 1, year_today = 94;
	long	channel = 21;
	long	starttime = 1800, duration = 30;
	long	newspaper = 0;

	printf("Channel [%ld]? ", channel);
	fgets(buffer, sizeof buffer, stdin);
	if (buffer[0] != '\n')
		channel = atol(buffer);

	printf("Month [%ld]? ", month_today);
	fgets(buffer, sizeof buffer, stdin);
	if (buffer[0] != '\n')
		month_today = atol(buffer);

	printf("Year [%ld]? ", year_today);
	fgets(buffer, sizeof buffer, stdin);
	if (buffer[0] != '\n')
		year_today = atol(buffer);

	readin(channel, month_today, year_today);
	printout();
	return 0;
}


static fnc	*head = NULL;


void
readin( long channel, long month_today, long year_today )
{
	static char	buffer[256];
	char	*cptr;
	FILE	*in;
	fnc	*fptr, *sptr, *prev;

	if (in = fopen("fnc7.tbl", "r")) {
		while (!feof(in) && fgets(buffer, sizeof buffer, in)) {
			if (buffer[0] == '\n' || buffer[0] == '#')
				continue;

			fptr = ( fnc * ) malloc( sizeof( fnc ));
			fptr->newspaper = atol(buffer);
			cptr = strchr(buffer, '\t') + 1;
			fptr->top5 = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->bot3 = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->channel = atoi(cptr);

			if (fptr->channel != ( int ) channel)
				continue;

			cptr = strchr(cptr, '\t') + 1;
			fptr->day = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->month = atoi(cptr);

			if (fptr->month != ( int ) month_today)
				continue;

			cptr = strchr(cptr, '\t') + 1;
			fptr->year = atoi(cptr);

			if (fptr->year != ( int ) year_today)
				continue;

			cptr = strchr(cptr, '\t') + 1;
			fptr->s4_out = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->s5_out = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->bump = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->start = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->duration = atoi(cptr);

			/* link in */
			sptr = head;
			prev = NULL;

			while (sptr) {
				if (sptr->start > fptr->start)
					break;
				else if (sptr->start == fptr->start) {
					if (sptr->duration > fptr->duration)
						break;
				}

				prev = sptr;
				sptr = sptr->next;
			}

			if (prev)
				prev->next = fptr;
			else
				head = fptr;

			fptr->next = sptr;
		}

		fclose(in);
	}

	return;
}


static void
printout( void )
{
	int	pstart, nl = 0;
	fnc	*fptr = head;

	while (fptr) {
		printf("%04d %03d", pstart = fptr->start, fptr->duration);
		fptr = fptr->next;

		if (fptr->start != pstart) {
			putchar('\n');
			nl++;

			if (fptr->start / 100 != pstart / 100) {
				putchar('\n');
				nl++;
			}
		}
		else {
			putchar(' ');
			putchar('|');
			putchar(' ');
		}

		if (nl >= 20) {
			while (!kbhit());
			getch();
			nl = 0;
		}
	}

	return;
}
