# include	<stdio.h>
# include	<stdlib.h>
# include	<string.h>

# ifndef OLD
/* # include	"vcrplus.h" */
# include	"ileave.h"
# endif

# include	"fnc7.h"


static fnc	*head = NULL;
static int	readflg = 0;

fnc *
reg( long newspaper, long top5, int bot3, int channel,
		int day_today, int month_today, int year_today,
		long s4_out, int s5_out, int bump,
		int starttime, int duration )
{
	int	match = 0;
	fnc	*fptr, *sptr, *prev = NULL;

	sptr = readtables();

	while (sptr) {
		if (sptr->top5 > top5)
			break;
		else if (sptr->top5 == top5) {
			if (sptr->year > year_today)
				break;
			else if (sptr->year == year_today) {
				if (sptr->month > month_today)
					break;
				else if (sptr->month == month_today) {
					/* function outputs should match */
					if (sptr->bump != bump || sptr->s4_out != s4_out)
						printf("\aClash with %04d,%d: ch%d, %d/%d/%d\n",
							sptr->start, sptr->duration, sptr->channel,
							sptr->day, sptr->month, sptr->year);
					else {
						if (sptr->s5_out > s5_out)
							break;
						else if (sptr->s5_out == s5_out) {
							/* already got it? */
							printf("\aAlready listed\n");
							return NULL;
						}
					}
				}
			}
		}

		prev = sptr;
		sptr = sptr->next;
	}
	
	/* no match */
	if (fptr = ( fnc * ) malloc( sizeof( fnc ))) {
		fptr->newspaper = newspaper;
		fptr->top5 = top5;
		fptr->bot3 = bot3;
		fptr->channel = channel;
		fptr->day = day_today;
		fptr->month = month_today;
		fptr->year = year_today;
		fptr->s4_out = s4_out;
		fptr->s5_out = s5_out;
		fptr->bump = bump;
		fptr->start = starttime;
		fptr->duration = duration;

		/* link it in */
		if (prev)
			prev->next = fptr;
		else
			head = fptr;

		fptr->next = sptr;
		readflg = 2;
	}
	else
		printf("\aOut of space!\n");
	return NULL;
}

void
change7( void )
{

	readflg = 2;
	return;
}

void
writeout( void )
{
	FILE	*out;
	fnc	*fptr = head;

	if (readflg == 2) {
		unlink("fnc7.bak");
		rename("fnc7.tbl", "fnc7.bak");

		if (out = fopen("fnc7.tbl", "w")) {
			while (fptr) {
				fprintf(out, "%07ld\t%04ld\t%03d\t%02d\t%02d\t%02d\t%02d\t%04ld\t%03d\t%02d\t%04d\t%03d\n",
					fptr->newspaper,
					fptr->top5,
					fptr->bot3,
					fptr->channel,
					fptr->day,
					fptr->month,
					fptr->year,
					(fptr->s4_out & S4_BITS),
					fptr->s5_out,
					fptr->bump,
					fptr->start,
					fptr->duration);
				fptr = fptr->next;
			}

			fclose(out);
		}
	}

	exit(0);
}


fnc *
readtables( void )
{
	static char	buffer[256];
	char	*cptr;
	FILE	*in;
	fnc	*fptr, *prev = NULL;

	if (readflg != 0)
		return head;

	if (in = fopen("fnc7.tbl", "r")) {
		while (!feof(in) && fgets(buffer, sizeof buffer, in)) {
			if (buffer[0] == '\n' || buffer[0] == '#')
				/* ignore space and comments */
				continue;

			fptr = ( fnc * ) malloc( sizeof( fnc ));
			fptr->newspaper = atol(buffer);
			cptr = strchr(buffer, '\t') + 1;
			fptr->top5 = atol(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->bot3 = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->channel = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->day = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->month = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->year = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->s4_out = atol(cptr);
			fptr->s4_out |= ((fptr->channel-1) & 0x10)? C4_BIT: 0;
			fptr->s4_out |= ((fptr->channel-1) & 0x20)? C5_BIT: 0;
			cptr = strchr(cptr, '\t') + 1;
			fptr->s5_out = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->bump = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->start = atoi(cptr);
			cptr = strchr(cptr, '\t') + 1;
			fptr->duration = atoi(cptr);

			/* link in */
			if (prev)
				prev->next = fptr;
			else
				head = fptr;

			fptr->next = NULL;
			prev = fptr;
		}

		fclose(in);
	}

	readflg = 1;
	return head;
}


fnc *
func7( long s4_out, int month, int year, fnc *fptr )
{

	if (fptr == NULL)
		/* start from the head */
		fptr = readtables();
	else
		/* start from the one after the one given */
		fptr = fptr->next;

	while (fptr) {
		if (fptr->s4_out == s4_out &&
		    fptr->month == month &&
		    fptr->year == year)
			    break;

		fptr = fptr->next;
	}

	return fptr;
}


int
set_dlist( int d_array[], int arraylen, int channel, int month,
						int year, int start)
{
	int	index = 0;
	fnc	*fptr;
# ifndef OLD
	long	tblidx = -1;
	long	s4_out;
	int	s5_out;
# endif

	readtables();

# ifdef OLD
	while (fptr) {
/* */		if (/*fptr->channel == channel &&*/ fptr->month == month &&
		    fptr->year == year && fptr->start == start) {
			if (index >= arraylen)
				/* out of space */
				break;

			/* remember duration */
			d_array[index] = fptr->duration;
			index++;
		}

		fptr = fptr->next;
	}
# else

	while ((tblidx = scanforstart(start, tblidx)) >= 0) {
		/* find relevant 's4_out' bits */
		interleave(tblidx, channel-1, (&s4_out), (&s5_out));

		/* look for a match in fnc7 tables */
		for (fptr = head; fptr; fptr = fptr->next) {
/* */			if (/*fptr->channel == channel &&*/ fptr->month == month &&
		    	    fptr->year == year && fptr->s4_out == s4_out) {
				if (index >= arraylen)
					/* out of space */
					break;

				/* remember duration */
				d_array[index] = getduration(tblidx);
				index++;
				break;
			}
		}
	}
# endif

	return index;
}

int
makebump( long top5 )
{
	int	a = ( int ) (top5/10000);
	int	b = ( int )((top5/1000)%10);
	int	c = ( int )((top5/100)%10);
	int	d = ( int )((top5/10)%10);
	int	e = ( int ) (top5%10);

/*	if (a) a += 20;		/* this is a bit suspicious.... */
/*	b += 2;			/* this experiment seems to move channel-nos up by one */
	return (a + b + c + d + e) % 32;
}


/*
 * Remove duplicate 'top5' entries
 */
void
killduptop5( void )
{
	fnc	*prev, *fptr = NULL;

	if (prev = readtables())
		fptr = prev->next;

	while (fptr) {
		while (fptr && (fptr->top5 == prev->top5 && 
		       fptr->month == prev->month &&
		       fptr->year == prev->year &&
		       fptr->s4_out == prev->s4_out &&
		       fptr->bump == prev->bump))
			fptr = fptr->next;

		prev = prev->next = fptr;
		if (fptr)
			fptr = fptr->next;
	}

	return;
}

void
prune7( int ( *test )( fnc *ptr ))
{
	fnc	*fptr, *prev = NULL;

	fptr = readtables();

	while (fptr) {
		if ((*test)(fptr) == 0) {
			/* dump this one */
			if (prev)
				fptr = prev->next = fptr->next;
			else
				fptr = head = fptr->next;
		}
		else {
			prev = fptr;
			fptr = fptr->next;
		}
	}

	return;
}

fnc *
s4pairsonly( void )
{
	fnc	*fptr, *prev = NULL;

	fptr = readtables();

	while (fptr) {
		if (fptr->s4_out == fptr->next->s4_out) {
			/* step past the pair */
			prev = fptr->next;
			fptr = prev->next;
		}
		else {
			/* remove orphan entry */
			if (prev)
				fptr = prev->next = fptr->next;
			else
				fptr = head = fptr->next;
		}
	}

	return head;
}


fnc *
reorder7( int (*test)( fnc *aptr, fnc *bptr ) )
{
	fnc	*prev2, *optr, *head2 = head, *fptr = head->next, *tptr;

	head2->next = NULL;
		
	while (fptr) {
		/* where do I insert it? */
		prev2 = NULL;
		for (optr = head2; optr; optr = optr->next) {
			if ((*test)(optr, fptr) > 0)
				break;

			prev2 = optr;
		}

		tptr = fptr->next;

		if (prev2)
			/* insert 'fptr' between 'prev2' and 'optr' */
			prev2->next = fptr;
		else
			/* insert 'fptr' between 'head2' and 'optr' */
			head2 = fptr;

		fptr->next = optr;
		fptr = tptr;
	}

	return (head = head2);
}

void
pr( fnc *fptr )
{

	printf("decode7(%04ld,%02d,%02d) -> %s", fptr->top5, fptr->month,
			fptr->year, pr_s4out(fptr->s4_out));

	return;
}


void
pr_rev( fnc *fptr )
{

	printf("encode7(%s,%02d,%02d) -> %04ld", pr_s4out(fptr->s4_out),
			fptr->month, fptr->year, fptr->top5);

	return;
}

char *
pr_s4out( long s4_out )
{
	static char	buffer[32];

	sprintf(buffer, "%04ld(%s%s)", s4_out & S4_BITS,
			(s4_out & C4_BIT)? "+C4": "",
			(s4_out & C5_BIT)? "+C5": ""
	);
	return buffer;
}


